#include "ot4xb.ch"
// ---------------------------------------------------------------------------
CLASS TPing
EXPORTED:
CLASS VAR _afp_
VAR pBuffer,hIcmp       
VAR cIp,nIp,nStatus,nTime,nTtl
       // --------------------------------------------------------------------
INLINE CLASS METHOD initclass()
       @ws2_32:WSAStartup(0x0101,Chrr(0,1024))
       ::_afp_ := Array(3)
       ::_afp_[1] := nGetProcAddress("IpHlpApi", "IcmpCreateFile" )
       if Empty( ::_afp_[1] ) // Win2K
          ::_afp_[1] := nGetProcAddress("Icmp", "IcmpCreateFile" )
          ::_afp_[2] := nGetProcAddress("Icmp", "IcmpCloseHandle" )
          ::_afp_[3] := nGetProcAddress("Icmp", "IcmpSendEcho" )
       else
          ::_afp_[2] := nGetProcAddress("IpHlpApi", "IcmpCloseHandle" )
          ::_afp_[3] := nGetProcAddress("IpHlpApi", "IcmpSendEcho" )
       end
       return Self
       // --------------------------------------------------------------------
INLINE CLASS METHOD ntoa(n) ; return FpQCall({"Ws2_32","inet_ntoa"},"c_sz__sl",n)
       // --------------------------------------------------------------------

INLINE CLASS METHOD cHostByName(cHost)
       local pHost
       local aAddr
       if Valtype(cHost) != "C" ; return NIL ; end
       @ws2_32:WSASetLastError(0)
       pHost := @Ws2_32:gethostbyname(cHost)
       if Empty(pHost) ; return NIL ; end
       aAddr := PeekByte(PeekDWord(PeekDWord(pHost,12)),0,4)
       return cPrintf("%i.%i.%i.%i",aAddr[1],aAddr[2],aAddr[3],aAddr[4])
       // --------------------------------------------------------------------
INLINE CLASS METHOD nHostByName(cHost)
       local pHost
       local aAddr
       if Valtype(cHost) != "C" ; return NIL ; end
       @ws2_32:WSASetLastError(0)
       pHost := @Ws2_32:gethostbyname(cHost)
       if Empty(pHost) ; return NIL ; end
       return PeekDWord(PeekDWord(PeekDWord(pHost,12)))
       // --------------------------------------------------------------------
INLINE CLASS METHOD IcmpCreateFile() ; return nFpCall( ::_afp_[1] )
       // --------------------------------------------------------------------
INLINE CLASS METHOD IcmpCloseHandle(h) ; return FpQCall(::_afp_[2],"__sl__sl",h)
       // --------------------------------------------------------------------
INLINE CLASS METHOD IcmpSendEcho(p1,p2,p3,p4,p5,p6,p7,p8)
       return FpQCall( ::_afp_[3] ,"__sl__sl__sl__pt__us__pt__pt__sl__ul",;
                       p1,p2,p3,p4,p5,@p6,p7,p8;
                     )
       // --------------------------------------------------------------------
INLINE METHOD init()
       ::Destroy()
       ::hIcmp    := ::IcmpCreateFile()
       if ::hIcmp == -1
          ::hIcmp := NIL
       else
          ::pBuffer  := _xgrab( 1024 )
       end
       return Self
       // --------------------------------------------------------------------
INLINE METHOD Destroy()
       if ::hIcmp != NIL ; ::IcmpCloseHandle(::hIcmp) ; ::hIcmp := NIL ; end
       if ::pBuffer != NIL ; _xfree( ::pBuffer ) ; ::pBuffer := NIL ; end
       return Self
       // --------------------------------------------------------------------
INLINE METHOD reset()
       ::cIp := ::nIp := ::nStatus := ::nTime := ::nTtl := NIL
       if ::pBuffer != NIL ; _bset(::pBuffer,0,1024) ; end
       return Self
       // --------------------------------------------------------------------
INLINE METHOD Ping( cHost , nTimeOut )
       local p := ::pBuffer
       local nHost,cReq,dw
       ::reset()
       if ::hIcmp == NIL ; return .F. ; end
       nHost := ::nHostByName( cHost )
       if nHost == NIL ; return .F. ; end
       DEFAULT nTimeOut := 5000
       cReq := cGenRndStr(32,.T.)
       dw := ::IcmpSendEcho(::hIcmp,nHost,cReq,Len(cReq),0,p,1024,nTimeOut)
       if (dw == 0 ) ; return .F. ; end 
       ::nIp     := PeekDWord(p,0)
       ::cIp     := ::ntoa(::nIp)
       ::nStatus := PeekDWord(p,4)
       ::nTime   := PeekDWord(p,8)
       ::nTtl    := PeekByte(p,20)
       return .T.
       // --------------------------------------------------------------------
ENDCLASS
// ---------------------------------------------------------------------------

